%define anolis_release 2
%global pkg intel_dlb2
%define pkg_version 8.2.0
%global debug_package %{nil}
%global kernel 5.10.134-17.an8

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:        Intel DLB2 Driver

License:        GPLv2.0+
URL:            https://www.intel.com/content/www/us/en/download/686372/773770/intel-dynamic-load-balancer.html
Source0:        kmod-intel_dlb2-8.2.0.tar.gz
Epoch:          1

ExclusiveArch:  x86_64

Requires:            kernel >= %{kernel}
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  kernel-headers = %{kernel}
BuildRequires:  kernel-devel = %{kernel}
Provides:       kmod-intel_dlb2 = %{release}
Obsoletes:      kmod-intel_dlb2 < %{release}
Obsoletes:      kmod-intel_dlb2 < %{pkg_version}-3%{?dist}
Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
Implementation of the dlb2 driver

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/dlb2
%{__install} -D -t %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/dlb2 src/dlb2.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/dlb2 -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1
if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/dlb2/dlb2.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
# 这里换成自己的ko路径，目的是将ko路径都保存到一个临时文件里然后在%postun阶段从weak-modules里注销。
echo "/lib/modules/%{kernel}.%{_arch}/extra/dlb2/dlb2.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

# 将模块的ko从weak-modules里注销，这里的rpm-%{pkg}-modules.list是在%preun阶段生成的。
if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
%defattr(644,root,root,755)
%license licenses
/lib/modules/%{kernel}.%{_arch}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Thu Dec 21 2023 Xingrui Yi <yixingrui@linux.alibaba.com> - 8.2.0-2
- Remove dracut

* Thu Nov 9 2023 Xingrui Yi <yixingrui@linux.alibaba.com> - 8.2.0-1
- Change spec to OOT weak module
